Program Top_Sort;
Uses Crt;

Const
  Max = 5;

Type
  Lref = ^Leader;
  Tref = ^Trailer;
  Leader = record
    Name,Cout : integer;
    Next      : Lref;
    Trail     : Tref;
  End;
  Trailer = record
    Id   : Lref;
    Next : Tref;
  End;
  TMat = array [1..Max,1..Max] of integer;

Const
  Matrix : TMat = ((0,0,0,0,0),
                   (1,0,1,1,0),
                   (1,0,0,1,0),
                   (1,1,0,0,0),
                   (0,1,0,0,0));

Var
  Head    : Lref;

Function Find0(H : Lref) : Lref;
Begin
  While (H^.Cout<>0) and (H<>Nil) do
    H:=H^.Next;
  Find0:=H;
End;

Function FindNum(Num: integer; H : Lref) : Lref;
Begin
  While (H^.Name<>Num) and (H<>Nil) do
    H:=H^.Next;
  FindNum:=H;
End;

Function InitList : Lref;
Var
  i   : integer;
  P,Q : Lref;
Begin
  Q:=Nil;
  For i:= 1 to Max do
    Begin
      New(P);
      P^.Name:=i;
      P^.Cout:=0;
      P^.Trail:=Nil;
      P^.Next:=Q;
      Q:=P;
    End;
  InitList:=Q;
End;

Procedure AddItem(V1,V2 : integer; H : Lref);
Var
  P1,P2 : Lref;
  Tr    : Tref;
Begin
  P1:=FindNum(V1,H);
  P2:=FindNum(V2,H);
  Inc(P2^.Cout);
  New(Tr);
  Tr^.Id:=P2;
  Tr^.Next:=P1^.Trail;
  P1^.Trail:=Tr;
End;

Function MakeList : Lref;
Var
  H   : Lref;
  i,j : integer;
Begin
  H:=InitList;
  For i:=1 to Max do
    For j:=1 to Max do
      If Matrix[i,j]<>0 then
        AddItem(i,j,H);
  MakeList:=H;
End;

Procedure TopSort(H : Lref);
Var
  P : Lref;
  Q : Tref;
  i : integer;
Begin
  i:=0;
  P:=Find0(H);
  while P<>Nil do
    Begin
      Write(P^.Name:3);
      Dec(P^.Cout);
      Q:=P^.Trail;
      While Q<>Nil do
        Begin
          Dec(Q^.Id^.Cout);
          Q:=Q^.Next;
        End;
      P:=Find0(H);
      Inc(i);
    End;
  If i<Max then
    Begin
      WriteLn;
      WriteLn('   横!');
    End;
End;

BEGIN
  ClrScr;
  Head:=MakeList;
  TopSort(Head);
  ReadLn;
END.